C**********************************************************************C
C       FEDAR.FOR		MARCH 5, 1987                          C
C                                                                      C
C       FOR ARBITRARY PLANE AND AXISYMMETRIC POROUS MEDIA              C
C                                                                      C
C	INPUT FILE:                                                    C
C         INTERACTIVE INPUT                                            C
C       OUTPUT FILE:                                                   C
C         INTERACTIVE OUTPUT RESULTS                                   C
C	  UNIT=1, FILENAME= JUNK1                                      C
C	  UNIT=2, FILENAME= JUNK2                                      C
C	JUNK1 AND JUNK2 ARE ONLY FOR TEMPORARY USE.                    C
C**********************************************************************C
      PARAMETER (MEL=300,MNT=310)
      IMPLICIT INTEGER*2(I-N)                                           MAIN   1
      COMMON /B/ C(122,31),R(MNT),FX(MNT),X(MNT),Y(MNT),ANG(MEL)      
     1,XK1(30),XK2(30),RO(30),ALPHA(40)                                 MAIN   4
      COMMON /DA/ BETA,HED(20),HITE,HEAD,NPAGE,NDMP,NTYPE,MAXMSH,NUMNP,IMAIN   5
     1,NUMEL,MAXBAN,NUMMAT,NUMFSC,NFLCD,MAXIT,MBAND,NUMNPM,NUMELM,NUMMAMMAIN   6
     2,NUMFSM,NFLCDM,NBC(MNT),MESH(MNT),NP(5,MEL),NPFS(40),NUMBLK,NBL   MAIN   7
      COMMON /PLO/ P(MNT),MJERA,NPOD,IPOD
C
      DIMENSION SLUSH(MEL,6)
C  
 21   FORMAT(//5X,'SEEPAGE PROBLEM ANALYSIS BY FEDAR.FOR'//5X,
     >'  INTERACTIVE INPUT'//5X,' PLEASE STATE YOUR INPUT FILE NAME FOR 
     >UNIT=5'//5X,' PLEASE STATE YOUR OUTPUT FILE NAME FOR UNIT=6 '//5X,
     >'DO NOT BE BOTHERED BY THE FILES, JUNK1 AND JUNK2, AFTER THE '/5X,
     >'PROGRAM IS EXECUTED.'//'********    GOOD LUCK    ********'//)
      WRITE(*,21)
C
      OPEN(UNIT=1,FILE='JUNK1',FORM='UNFORMATTED',ACCESS='SEQUENTIAL',
     >     STATUS='NEW')
      OPEN(UNIT=2,FILE='JUNK2',FORM='UNFORMATTED',ACCESS='SEQUENTIAL',
     >     STATUS='NEW')
      OPEN(UNIT=5,FILE=' ',ACCESS='SEQUENTIAL',STATUS='OLD')
      OPEN(UNIT=6,FILE=' ',ACCESS='SEQUENTIAL',STATUS='NEW')
C
      NDISC=1                                                           MAIN   9
      NDISC1=2                                                          MAIN  10
      MBAND=31                                                                  
      NBL=MBAND*2                                                       MAIN  12
      NUMNPM=250                                                                
      NUMELM=220                                                        MAIN  14
      NUMMAM=20                                                         MAIN  15
      NUMFSM=220                                                        MAIN  16
      NFLCDM=40                                                         MAIN  17
      MJERA=0                                                                   
      IPOD=0                                                                    
  31  CONTINUE                                                          MAIN  18
      IF(IPOD.EQ.0) NPOD=0                                                      
C      IF(MJERA.GT.0.OR.NPOD.GT.0) CALL PLOTF                                    
C......................................................... WRITE IN MAIN
      WRITE(6,2015)                                                     MAIN  19
2015  FORMAT(1H1,18H START OF PROBLEM   ////)                           MAIN  20
C     INITIALIZATION                                                            
      NDMP=0                                                            MAIN  21
      NPAGE=0                                                           MAIN  22
      NUMIT=0                                                           MAIN  23
      CALL INPUT                                                        MAIN  24
      IF(NDMP.NE.0) GO TO 30                                                    
  32  CONTINUE                                                          MAIN  25
C     FORM MATRICES FOR SOLUTION                                                
      CALL PAGE                                                         MAIN  26
      CALL QDFLOW (SLUSH)                                               MAIN  27
      IF (NDMP) 5000,5000,30                                            MAIN  28
5000  CONTINUE                                                          MAIN  29
C     SOLVE EQUATIONS                                                           
      CALL BANSOL (MAXBAN,NUMBLK,C,R,MBAND)                             MAIN  30
C     PRINT ANSWER                                                              
  34  CONTINUE                                                          MAIN  31
      CALL OUTPUT (SLUSH,NUMIT)                                         MAIN  32
      IF (NUMIT.LT.MAXIT) GO TO 32                                      MAIN  33
  33  CONTINUE                                                          MAIN  34
      GO TO 31                                                          MAIN  35
  30  CONTINUE                                                          MAIN  36
      IF(IPOD.EQ.0) NPOD=0                                                      
C     IF(NUMIT.EQ.0.AND.(MJERA.GT.0.OR.NPOD.GT.0)) CALL PLOTF                   
      IF (NUMIT.EQ.0) GO TO 36                                          MAIN  37
      REWIND NDISC1                                                     MAIN  38
      MAXIT=NUMIT-1                                                     MAIN  39
      NUMIT=MAXIT                                                       MAIN  40
C.......................................................... READ IN MAIN
      READ (NDISC1) (X(I),Y(I),R(I),I=1,NUMNP)                          MAIN  41
      DO 35 J=1,6                                                       MAIN  42
C.......................................................... READ IN MAIN
  35  READ (NDISC1) (SLUSH(I,J),I=1,NUMEL)                              MAIN  43
      CALL PAGE                                                         MAIN  44
      GO TO 34                                                          MAIN  45
36    STOP
      END                                                               MAIN  46
C***********************************************************************
C	SUBROUTINE FOR PAGE NUMBER                                     *
C***********************************************************************
      SUBROUTINE PAGE
C   
      PARAMETER (MEL=300,MNT=310)                                       PAGE   1
      IMPLICIT INTEGER*2(I-N)                                           PAGE   2
      COMMON /B/ C(122,31),R(MNT),FX(MNT),X(MNT),Y(MNT),ANG(MEL)        PAGE   3
     1,XK1(30),XK2(30),RO(30),ALPHA(40)                                 PAGE   4
      COMMON /DA/ BETA,HED(20),HITE,HEAD,NPAGE,NDMP,NTYPE,MAXMSH,NUMNP,IPAGE   5
     1,NUMEL,MAXBAN,NUMMAT,NUMFSC,NFLCD,MAXIT,MBAND,NUMNPM,NUMELM,NUMMAMPAGE   6
     2,NUMFSM,NFLCDM,NBC(MNT),MESH(MNT),NP(5,MEL),NPFS(40),NUMBLK,NBL   PAGE   7
      COMMON /PLO/ P(MNT),MJERA,NPOD,IPOD
C
      NPAGE =NPAGE+1
C......................................................... WRITE IN PAGE
      WRITE (6,200) NPAGE
 200  FORMAT (41H1 H. T. CHAN RM. 137. DEPT. OF CIVIL ENG.       ,15X
     1,46HARBITRARY PLANE AND AXISYMMETRIC POROUS MEDIA      ,15X,I5,/)
C......................................................... WRITE IN PAGE
      WRITE (6,2000) HED
2000  FORMAT (20A4)
      IF (NTYPE-1) 84,85,84
C......................................................... WRITE IN PAGE
  84  WRITE(6,2001)
      GO TO 86
C......................................................... WRITE IN PAGE
  85  WRITE(6,2002)
  86  CONTINUE
2001  FORMAT (27H AXISYMMETRIC FLOW PROBLEM /)
2002  FORMAT (20H PLANE FLOW PROBLEM /)
      RETURN
      END
C***********************************************************************
C	SUBROUTINE FOR DATA INPUT                                      *
C***********************************************************************
      SUBROUTINE INPUT                                                  INPU   1
C   
      PARAMETER (MEL=300,MNT=310)                                       INPU   1
      IMPLICIT INTEGER*2(I-N)                                           INPU   2
      COMMON /B/ C(122,31),R(MNT),FX(MNT),X(MNT),Y(MNT),ANG(MEL)        INPU   3
     1,XK1(30),XK2(30),RO(30),ALPHA(40)                                 INPU   4
      COMMON /DA/ BETA,HED(20),HITE,HEAD,NPAGE,NDMP,NTYPE,MAXMSH,NUMNP,IINPU   5
     1,NUMEL,MAXBAN,NUMMAT,NUMFSC,NFLCD,MAXIT,MBAND,NUMNPM,NUMELM,NUMMAMINPU   6
     2,NUMFSM,NFLCDM,NBC(MNT),MESH(MNT),NP(5,MEL),NPFS(40),NUMBLK,NBL   INPU   7
      COMMON /PLO/ P(MNT),MJERA,NPOD,IPOD
C.......................................................... READ IN INPU
  30  READ(5,1000,ERR=500,END=500) HED,NUMNP,NUMEL,NUMMAT,NUMFSC,NTYPE,         
     1NFLCD,HITE,HEAD,BETA,MAXIT,MJERA,NPOD,INPU                               
      IPOD=0                                                                    
      IF (INPU.EQ.0) INPU=5                                                   
      GO TO 501                                                                 
500   STOP
 501  CALL PAGE                                                                 
      IF (ABS(HEAD).LE.0.1E-25) NDMP=1                                  INPU  11
      IF (ABS(HEAD).LE.0.1E-25) WRITE(6,105)                            INPU  12
 105  FORMAT (1X,19HHEAD CANNOT BE ZERO)                                INPU  13
      IF (NUMNP.LT.3.OR.NUMNP.GT.NUMNPM) NDMP=1                         INPU  14
      IF (NUMNP.LT.3.OR.NUMNP.GT.NUMNPM) WRITE (6,100)                  INPU  15
      IF (NUMEL.LT.1.OR.NUMEL.GT.NUMELM) NDMP=1                                 
      IF (NUMEL.LT.1.OR.NUMEL.GT.NUMELM) WRITE(6,102)                           
      IF (NUMMAT.LT.1.OR.NUMMAT.GT.NUMMAM) NDMP=1                       INPU  18
      IF (NUMMAT.LT.1.OR.NUMMAT.GT.NUMMAM) WRITE (6,104)                INPU  19
      IF (NUMFSC.LT.0.OR.NUMFSC.GT.NUMFSM) NDMP=1                       INPU  20
      IF (NUMFSC.LT.0.OR.NUMFSC.GT.NUMFSM) WRITE (6,106)                INPU  21
      IF (NFLCD.LT.0.OR.NFLCD.GT.NFLCDM) NDMP=1                         INPU  22
      IF (NFLCD.LT.0.OR.NFLCD.GT.NFLCDM) WRITE (6,108)                  INPU  23
      IF (BETA.LT.0.5.OR.BETA.GT.1.5) NDMP=1                            INPU  24
      IF (BETA.LT.0.5.OR.BETA.GT.1.5) WRITE (6,110)                     INPU  25
      IF (MJERA.LT.0) NDMP=1                                                    
      IF (MJERA.LT.0) WRITE(6,138)                                              
      IF (NPOD.LT.0)  NDMP=1                                                    
      IF (NPOD.LT.0)  WRITE(6,140)                                              
      IF (NPOD.LT.0)  NOPD=0                                                    
      IF (NPOD.GT.20) NDMP=1                                                    
      IF (NPOD.GT.20) WRITE(6,142)                                              
      IF (NPOD.GT.20) NPOD=0                                                    
      WRITE(6,2000) NUMNP,NUMEL,NUMMAT,NUMFSC,NTYPE,NFLCD,HITE,HEAD,    INPU  26
     1BETA,MAXIT                                                        INPU  27
      CALL PAGE                                                         INPU  28
      DO 1 N=1,NUMMAT                                                   INPU  29
      M=N                                                               INPU  30
C.......................................................... READ IN INPU
      READ(5,1001) M,XK1(M),XK2(M),RO(M)                                INPU  31
      IF (M.NE.N) NDMP=1                                                INPU  32
      IF (M.NE.N) WRITE (6,103)                                         INPU  33
 103  FORMAT (1X,36HMATERIAL NUMBERS IN INCORRECT ORDER  )              INPU  34
      IF (XK1(N).LT.0.0) NDMP=1                                         INPU  35
      IF (XK1(N).LT.0.0) WRITE (6,112) N                                INPU  36
      IF (XK2(N).LT.0.0) NDMP=1                                         INPU  37
      IF (XK2(N).LT.0.0) WRITE (6,114) N                                INPU  38
      IF (RO(N).LT.0.0) NDMP=1                                          INPU  39
      IF (RO(N).LT.0.0) WRITE (6,116) N                                 INPU  40
   1  CONTINUE                                                          INPU  41
      WRITE(6,2003)(N,XK1(N),XK2(N),RO(N),N=1,NUMMAT)                   INPU  42
C     READ AND PRINT NODAL INFORMATION                                          
      CALL PAGE                                                         INPU  43
C.......................................................... READ IN INPU
      READ(INPU,1002) M,IM,NBC(M),X(M),Y(M),FX(M)                              
      IF (M.LT.1.OR.M.GT.NUMNP) NDMP=1                                  INPU  45
      IF (M.LT.1.OR.M.GT.NUMNP) WRITE (6,118) M                         INPU  46
      MMM=1                                                             INPU  47
      MESH(MMM)=M                                                       INPU  48
      DO 60 I=1,NUMNP                                                   INPU  49
C.......................................................... READ IN INPU
      READ(INPU,1002) N,IN,NBC(N),X(N),Y(N),FX(N)                              
      IF (N.LT.1.OR.N.GT.NUMNP) NDMP=1                                  INPU  51
      IF (N.LT.1.OR.N.GT.NUMNP) WRITE (6,118) N                         INPU  52
      MMM=MMM+1                                                         INPU  53
      MESH(MMM)=N                                                       INPU  54
      NMM=N-M                                                           INPU  55
      XNMM=NMM                                                          INPU  56
      DX=(X(N)-X(M))/XNMM                                               INPU  57
      DY=(Y(N)-Y(M))/XNMM                                               INPU  58
      DF=(FX(N)-FX(M))/XNMM                                             INPU  59
      MP1=M+1                                                           INPU  60
      IF (MP1-N) 160,161,161                                            INPU  61
 160  NM1=N-1                                                           INPU  62
      DO 61 NN=MP1,NM1                                                  INPU  63
      X(NN)=X(NN-1)+DX                                                  INPU  64
      Y(NN)=Y(NN-1)+DY                                                  INPU  65
      NBC(NN)=0                                                         INPU  66
      FX(NN)=0.0                                                        INPU  67
      IF (IM-0) 64,61,64                                                INPU  68
  64  NBC(NN)=NBC(M)                                                    INPU  69
      FX(NN)=FX(NN-1)+DF                                                INPU  70
  61  CONTINUE                                                          INPU  71
 161  IF(N-NUMNP) 65,63,63                                              INPU  72
  65  M=N                                                               INPU  73
      IM=IN                                                             INPU  74
  60  CONTINUE                                                          INPU  75
  63  WRITE(6,2004) (N,NBC(N),X(N),Y(N),FX(N),N=1,NUMNP)                INPU  76
      MAXMSH=MMM                                                        INPU  77
C     READ ELEMENT CARDS                                                        
      READ(INPU,1003) M,(NP(I,M),I=1,5),ANG(M)                                 
C.......................................................... READ IN INPU
      IF (M.LT.1.OR.M.GT.NUMEL) NDMP=1                                  INPU  79
      IF (M.LT.1.OR.M.GT.NUMEL) WRITE (6,120) M                         INPU  80
      IF(NP(5,M).LT.1.OR.NP(5,M).GT.NUMMAT) NDMP=1                      INPU  81
      IF(NP(5,M).LT.1.OR.NP(5,M).GT.NUMMAT) WRITE (6,128) M             INPU  82
      K=0                                                               INPU  83
      DO 340 I1=1,4                                                     INPU  84
      IF (NP(I1,M).LT.1.OR.NP(I1,M).GT.NUMNP) NDMP=1                    INPU  85
      IF (NP(I1,M).LT.1.OR.NP(I1,M).GT.NUMNP) WRITE (6,124) M           INPU  86
      DO 325 L1=1,4                                                     INPU  87
      KK= NP(I1,M)-NP(L1,M)                                             INPU  88
      IF(KK.LT.0) KK=0-KK                                               INPU  89
      IF (K-KK) 66,325,325                                              INPU  90
  66  K=KK                                                              INPU  91
 325  CONTINUE                                                          INPU  92
      IF(KK.GE.MBAND) WRITE(6,2014) M                                   INPU  93
 340  CONTINUE                                                          INPU  94
  75  DO 70 J=1,NUMEL                                                   INPU  95
      READ(INPU,1003) N,(NP(I,N),I=1,5),ANG(N)                                 
C.......................................................... READ IN INPU
      IF (N.LT.1.OR.N.GT.NUMEL) NDMP=1                                  INPU  97
      IF (N.LT.1.OR.N.GT.NUMEL) WRITE (6,122) N                         INPU  98
      IF(NP(5,N).LT.1.OR.NP(5,N).GT.NUMMAT) NDMP=1                      INPU  99
      IF(NP(5,N).LT.1.OR.NP(5,N).GT.NUMMAT) WRITE (6,130) N             INPU 100
      DO 440 I1=1,4                                                     INPU 101
      IF (NP(I1,N).LT.1.OR.NP(I1,N).GT.NUMNP) NDMP=1                    INPU 102
      IF (NP(I1,N).LT.1.OR.NP(I1,N).GT.NUMNP) WRITE (6,126) N           INPU 103
      DO 425 L1=1,4                                                     INPU 104
      KK= NP(I1,N)-NP(L1,N)                                             INPU 105
      IF (KK.LT.0) KK=0-KK                                              INPU 106
      IF(K-KK)67,425,425                                                INPU 107
  67  K=KK                                                              INPU 108
 425  CONTINUE                                                          INPU 109
      IF(KK.GE.MBAND) WRITE(6,2014) N                                   INPU 110
 440  CONTINUE                                                          INPU 111
      MP1=M+1                                                           INPU 112
      IF (MP1-N)68,171,171                                              INPU 113
  68  NM1=N-1                                                           INPU 114
      DO 71 NN=MP1,NM1                                                  INPU 115
      DO 72 I=1,4                                                       INPU 116
  72  NP(I,NN)=NP(I,NN-1)+1                                             INPU 117
      NP(5,NN)=NP(5,M)                                                  INPU 118
      ANG(NN)=ANG(M)                                                    INPU 119
  71  CONTINUE                                                          INPU 120
 171  IF(N-NUMEL) 69,74,74                                              INPU 121
  69  M=N                                                               INPU 122
  70  CONTINUE                                                          INPU 123
  74  CONTINUE                                                          INPU 124
      DO 3 N=1,NUMEL                                                    INPU 125
      IF (NP(4,N).EQ.NP(1,N).OR.NP(4,N).EQ.NP(2,N)) NP(4,N)=NP(3,N)     INPU 126
   3  CONTINUE                                                          INPU 127
      CALL PAGE                                                         INPU 128
      WRITE(6,2005) (N,(NP(I,N),I=1,5),ANG(N),N=1,NUMEL)                INPU 129
      MAXBAN=K+1                                                        INPU 130
      IF(MAXBAN-MBAND)32,32,31                                          INPU 131
  31  CONTINUE                                                          INPU 132
      NDMP=1                                                            INPU 133
      WRITE(6,144)                                                              
  32  IF(NFLCD-0)76,76,77                                               INPU 134
C     READ DISTRIBUTED FLOW INPUT CARDS                                         
  77  CONTINUE                                                          INPU 135
      CALL PAGE                                                         INPU 136
      WRITE (6,2001)                                                    INPU 137
2001  FORMAT (1X,16HFLOW INPUT RATES / 4X,1HI,4X,1HJ,6X,4HFLOW /)       INPU 138
      DO 62 N=1,NFLCD                                                   INPU 139
C.......................................................... READ IN INPU
      READ(INPU,1004) I,J,QIJ                                                  
      IF (I.LT.1.OR.I.GT.NUMNP) NDMP=1                                  INPU 141
      IF (I.LT.1.OR.I.GT.NUMNP) WRITE (6,132) N                         INPU 142
      IF (J.LT.1.OR.J.GT.NUMNP) NDMP=1                                  INPU 143
      IF (J.LT.1.OR.J.GT.NUMNP) WRITE (6,132) N                         INPU0144
      IF (NBC(I).GE.0) NDMP=1                                           INPU0145
      IF (NBC(I).GE.0) WRITE (6,136) I                                  INPU0146
      IF (NBC(J).GE.0) NDMP=1                                           INPU0147
      IF (NBC(J).GE.0) WRITE (6,136) J                                  INPU0148
      WRITE (6,1004) I,J,QIJ                                            INPU0149
      SIJ=SQRT((X(J)-X(I))**2+(Y(J)-Y(I))**2)                           INPU0150
      FX(I)=FX(I)+0.5*QIJ*SIJ                                           INPU0151
  62  FX(J)=FX(J)+0.5*QIJ*SIJ                                           INPU0152
C     READ FREE SURFACE DESCRIPTION                                             
  76  IF(NUMFSC-0)703,703,704                                           INPU0153
 704  CONTINUE                                                          INPU0154
      CALL PAGE                                                         INPU0155
C.......................................................... READ IN INPU
      READ(INPU,1005) (NPFS(I),ALPHA(I),I=1,NUMFSC)                            
      DO 2 I=1,NUMFSC                                                   INPU0157
      IF (NPFS(I).LT.1.OR.NPFS(I).GT.NUMNP) NDMP=1                      INPU0158
      IF (NPFS(I).LT.1.OR.NPFS(I).GT.NUMNP) WRITE (6,134)               INPU0159
      NPFSI=NPFS(I)                                                     INPUA159
      IF(NBC(NPFSI).GE.0) NDMP=1                                        INPU 160
      IF(NBC(NPFSI).GE.0) WRITE(6,136)NPFSI                             INPU 161
   2  CONTINUE                                                          INPU0162
      WRITE (6,2006)                                                    INPU0163
      WRITE(6,2007)(NPFS(I),ALPHA(I),I=1,NUMFSC)                        INPU0164
 703  IF (NUMFSC.LE.0) MAXIT=1                                          INPU0165
1000  FORMAT(20A4/,6I5,3F10.0,4I5)                                              
1001  FORMAT (I5,3F10.0)                                                INPU0167
1002  FORMAT (I5,I2,I3,3F10.0)                                          INPU0168
1003  FORMAT (6I5,F10.0)                                                INPU0169
1004  FORMAT (2I5,F10.0)                                                INPU 170
1005  FORMAT (I5,F10.0)                                                 INPU0171
2000  FORMAT (/ 30H  NUMBER OF NODAL POINTS------,I3/                   INPU0172
     1 30H  NUMBER OF ELEMENTS----------,I3/,30H  NUMBER OF DIFF. MARERIINPU0173
     2ALS---,I3 /, 30H  NUMBER OF FREE SURFACE NODES,I3/,               INPU 174
     330H  NUMBER INDICATING FLOW TYPE-,I3/,   30H  NUMBER OF FLOW INPUTINPU 175
     4 CARDS--,I3/, 30H  REFERENCE FOR EQUI. LINES---,E12.4/            INPU 176
     5        30H  AVAILABLE HEAD--------------,E12.4/                  INPU 177
     6        30H  CORRECTION FACTOR-----------,F10.6/                  INPU 178
     7        30H  NUMBER OF ITERATIONS--------,  I3/)                  INPU 179
2003  FORMAT (29H  MATERIAL     PERMEABILITIES//                        INPU 180
     1   56H  MATERIAL              K1             K2             RO//  INPU 181
     2 (I10,2E15.6,F15.6))                                              INPU 182
2004  FORMAT (51H NODE   BC          X ORD          Y ORD          F//  INPU 183
     1       (2I5,3F15.4))                                              INPU 184
2005  FORMAT (65H ELMT         I         J         K         L       MA INPU 185
     1     ANGLE//(I5,5I10,F10.3))                                      INPU 186
2006  FORMAT (13H FREE SURFACE//                                        INPU 187
     1        25H      NODF    CORR. ANGLE//)                           INPU 188
2007  FORMAT(I10,F15.4)                                                 INPU 189
2014  FORMAT (1X,48HMAXIMUM BAND WIDTH EXCEEDS ALLOWABLE FOR ELEMENT,I5)INPU 190
144   FORMAT(' PREVELIKI BAND')                                                 
142   FORMAT(' BROJ EKVIPOTENCIJALA VE_I OD 20')                                
140   FORMAT(' BROJ EKVIPOTENCIJALA MANJI OD 0')                                
138   FORMAT(' MJERILO NEGATIVNO')                                              
 136  FORMAT (1X,55HFIXED FLOW BOUNDARY CONDITION REQUIRED FOR NODAL POIINPU 191
     1NT ,I5 )                                                          INPU 192
 134  FORMAT (1X,37HINCORRECT NODAL POINT ON SURFACE CARD      ,I5)     INPU 193
 132  FORMAT (1X,37HINCORRECT NODAL POINT ON FLOW CARD         ,I5)     INPU 194
 130  FORMAT (1X,37HINCORRECT MATERIAL NUMBER ON ELEMENT  ,I5)          INPU 195
 128  FORMAT (1X,37HINCORRECT MATERIAL NUMBER ON ELEMENT  ,I5)          INPU 196
 126  FORMAT (1X,34HINCORRECT NODAL POINT FOR ELEMENT  ,I5)             INPU 197
 124  FORMAT (1X,34HINCORRECT NODAL POINT FOR ELEMENT  ,I5)             INPU 198
 122  FORMAT (1X,20HVALUE OF ELEMENT IS ,I5)                            INPU 199
 120  FORMAT (1X,20HVALUE OF ELEMENT IS    ,I5)                         INPU 200
 118  FORMAT (1X,27HCHECK VALUE OF NODAL POINT  ,I5)                    INPU 201
 116  FORMAT (1X,32HDENSITY IS NEGATIVE FOR MATERIAL   ,I5)             INPU 202
 114  FORMAT (1X,50HY DIRECTION PERMEABILITY IS NEGATIVE FOR MATERIAL   INPU 203
     1,I5)                                                              INPU 204
 112  FORMAT (1X,50HX DIRECTION PERMEABILITY IS NEGATIVE FOR MATERIAL   INPU 205
     1,I5)                                                              INPU 206
 110  FORMAT (1X,40HCHECK VALUE OF BETA BETWEEN 0.5 AND 1.5  )          INPU 207
 108  FORMAT (1X,34HCHECK NUMBER OF FIXED FLOW CARDS    )               INPU 208
 106  FORMAT (1X,34HCHECK NUMBER OF FREE SURFACE CARDS )                INPU 209
 104  FORMAT (1X,26HCHECK NUMBER OF MATERIALS  )                        INPU 210
 102  FORMAT (1X,          25HCHECK NUMBER OF ELEMENTS )                INPU 211
 100  FORMAT (1X,          27HCHECK NUMBER OF NODE POINTS  )            INPU 212
      RETURN                                                            INPU 214
      END                                                               INPU 215
C***********************************************************************
C	SUBROUTINE FOR DATA OUTPUT                                     *
C***********************************************************************
      SUBROUTINE OUTPUT (SLUSH,NUMIT)                                   OUTP   1
C
      PARAMETER (MEL=300,MNT=310)                                       OUTP   1
      IMPLICIT INTEGER*2(I-N)                                           OUTP   2
      COMMON /B/ C(122,31),R(MNT),FX(MNT),X(MNT),Y(MNT),ANG(MEL)        OUTP   3 
     1,XK1(30),XK2(30),RO(30),ALPHA(40)                                 OUTP   4
      COMMON /DA/ BETA,HED(20),HITE,HEAD,NPAGE,NDMP,NTYPE,MAXMSH,NUMNP,IOUTP   5
     1,NUMEL,MAXBAN,NUMMAT,NUMFSC,NFLCD,MAXIT,MBAND,NUMNPM,NUMELM,NUMMAMOUTP   6
     2,NUMFSM,NFLCDM,NBC(MNT),MESH(MNT),NP(5,MEL),NPFS(40),NUMBLK,NBL   OUTP   7
      COMMON /PLO/ P(MNT),MJERA,NPOD,IPOD
C
      DIMENSION SLUSH(MEL,6)                                            OUTP   9
C
      NDISC1=2                                                          OUTP  10
      REWIND NDISC1                                                     OUTP  11
      WRITE (NDISC1) (X(I),Y(I),R(I),I=1,NUMNP)                         OUTP  12
      DO 35 J=1,6                                                       OUTP  13
  35  WRITE(NDISC1) (SLUSH(I,J),I=1,NUMEL)                              OUTP  14
      ROE=RO(1)                                                         OUTP  15
      IF (ABS(ROE).LE.0.1E-25) ROE=1.                                   OUTP  16
      N=NUMIT+1                                                         OUTP  17
      NUM=NUMNP                                                         OUTP  18
      IF (N.LT.MAXIT) NUM=NUMFSC                                        OUTP  19
      WRITE (6,2008) N                                                  OUTP  20
      IPOD=1                                                                    
      DO 204 M=1,NUM                                                    OUTP  21
      N=M                                                               OUTP  22
      IF (NUMIT+1.LT.MAXIT) N=NPFS(M)                                   OUTP  23
      PSI=(R(N)+RO(1)*(Y(N)-HITE))/(HEAD*ROE)                           OUTP  24
      P(N)=PSI
      RMOD=R(N)/ROE                                                     OUTP  25
      EXHEAD=(Y(N)-HITE)*RO(1)/ROE+RMOD                                 OUTP  26
 204  WRITE(6,2011) N,R(N),PSI,RMOD,PSI,EXHEAD                          OUTP  27
   2  CONTINUE                                                          OUTP  28
      NUMIT=NUMIT+1                                                     OUTP  29
C     CORRECT NODAL POSITIONS ALONG FREE SURFACE                                
      IF (NUMIT-MAXIT) 206,203,203                                      OUTP  30
 206  DO 800 II=1,NUMFSC                                                OUTP  31
      M=NPFS(II)                                                        OUTP  32
      IF (ABS(ROE).LE.0.1E-25) R(M)=R(M)-Y(M)                           OUTP  33
      ALP=3.141593*ALPHA(II)/180.0                                      OUTP  34
      X(M)=X(M)+BETA*R(M)*COS(ALP)/ROE                                  OUTP  35
 800  Y(M)=Y(M)+BETA*R(M)*SIN(ALP)/ROE                                  OUTP  36
C     REGENERATE MESH                                                           
      M=MESH(1)                                                         OUTP  37
      DO 600 I=2,MAXMSH                                                 OUTP  38
      N=MESH(I)                                                         OUTP  39
      XNMM=N-M                                                          OUTP  40
      DX=(X(N)-X(M))/XNMM                                               OUTP  41
      DY=(Y(N)-Y(M))/XNMM                                               OUTP  42
      MP1=M+1                                                           OUTP  43
      DO 601 NN=MP1,N                                                   OUTP  44
      X(NN)=X(NN-1)+DX                                                  OUTP  45
 601  Y(NN)=Y(NN-1)+DY                                                  OUTP  46
      IF (N-NUMNP) 604,603,603                                          OUTP  47
 604  M=N                                                               OUTP  48
 600  CONTINUE                                                          OUTP  49
 203  CONTINUE                                                          OUTP  50
 603  IF(NUMIT.GE.MAXIT) CALL PAGE                                      OUTP  51
      WRITE (6,2004) NUMIT                                              OUTP  52
      NUM=NUMNP                                                         OUTP  53
      IF (NUMIT.LT.MAXIT) NUM=NUMFSC                                    OUTP  54
      DO 3 M=1,NUM                                                      OUTP  55
      N=M                                                               OUTP  56
      IF(NUMIT.LT.MAXIT) N=NPFS(M)                                      OUTP  57
   3  WRITE (6,2005) N,NBC(N),X(N),Y(N),FX(N)                           OUTP  58
      IF(NUMIT.LT.MAXIT) GO TO 700                                      OUTP  59
      CALL PAGE                                                         OUTP  60
      WRITE(6,2013)                                                     OUTP  61
C     SOLVE FOR ELEMENT FLOWS                                                   
      CALL ELFLOW (SLUSH)                                               OUTP  62
      DO 1 M=1,NUMEL                                                    OUTP  63
      WRITE (6,304) M,(SLUSH(M,II),II=1,5)                              OUTP  64
   1  CONTINUE                                                          OUTP  65
 304  FORMAT (I5,2E15.5,F10.4,E20.5,F15.4 )                             OUTP  66
2005  FORMAT (2I5,3F15.4)                                               OUTP  67
2008  FORMAT (/  /6H AFTER ,I5, 31H TRIALS THE NODAL PRESSURES ARE   // OUTP  68
     1        35H NODE       PRESSURE    EQUPOT LINE                    OUTP  69
     2  ,30H       PRESSURE    EQUPOT LINE          ,15H POTENTIAL HEAD)OUTP  70
2011  FORMAT (I5,2E15.5,3F15.5)                                         OUTP  72
2013  FORMAT (/1X,     13HELEMENT FLOWS//80H ELMT             Q1        OUTP  73
     1     Q2       ANG             TOTAL Q      DIRECTION//)           OUTP  74
2004  FORMAT(/6H AFTER ,I5, 7H TRIALS          //                       OUTP  76
     1        51H NODE   BC          X ORD          Y ORD          F// )OUTP  77
 700  CONTINUE                                                          OUTP  78
      RETURN                                                            OUTP  79
      END                                                               OUTP  80
C***********************************************************************
C	SUBROUTINE FOR FLOW                                            *
C***********************************************************************        
      SUBROUTINE QDFLOW(SLUSH)                                          QDFL   1
C     
      PARAMETER (MEL=300,MNT=310)
      IMPLICIT INTEGER*2(I-N)                                           QDFL   1
      COMMON /B/ C(122,31),R(MNT),FX(MNT),X(MNT),Y(MNT),ANG(MEL)      
     1,XK1(30),XK2(30),RO(30),ALPHA(40)                                 QDFL   4
      COMMON /DA/ BETA,HED(20),HITE,HEAD,NPAGE,NDMP,NTYPE,MAXMSH,NUMNP,IQDFL   5
     1,NUMEL,MAXBAN,NUMMAT,NUMFSC,NFLCD,MAXIT,MBAND,NUMNPM,NUMELM,NUMMAMQDFL   6
     2,NUMFSM,NFLCDM,NBC(MNT),MESH(MNT),NP(5,MEL),NPFS(40),NUMBLK,NBL   QDFL   7
      COMMON /PLO/ P(MNT),MJERA,NPOD,IPOD
C
      DIMENSION SLUSH(MEL,6)                                            QDFL   9
      DIMENSION XK(2,2),YY(6),FG(2),GG(5),S(5,5),IY(6),JY(6,4)          QDFL  10
C
      NDISC=1                                                           QDFL  11
      NDISC1=2                                                          QDFL  12
      REWIND NDISC                                                      QDFL  14
      DO 1 I=1,NUMNP                                                    QDFL  15
   1  R(I)=0.0                                                          QDFL  16
      DO 2 I=1,NBL                                                      QDFL  17
      DO 2 J=1,MAXBAN                                                   QDFL  18
   2  C(I,J)=0.0                                                        QDFL  19
      DO 10 I=1,3                                                       QDFL  20
      IY(I)=1                                                           QDFL  21
  10  IY(I+3)=2                                                         QDFL  22
      DO 20 J=1,4                                                       QDFL  23
      DO 25 I=3,6,3                                                     QDFL  24
  25  JY(I,J)=5                                                         QDFL  25
      JY(1,J)=J                                                         QDFL  26
  20  JY(4,J)=J                                                         QDFL  27
      DO 26 J=1,3                                                       QDFL  28
      JY(2,J)=J+1                                                       QDFL  29
  26  JY(5,J)=J+1                                                       QDFL  30
      JY(2,4)=1                                                         QDFL  31
      JY(5,4)=1                                                         QDFL  32
      NDMP=0                                                            QDFL  33
      A1=1.                                                             QDFL  34
      FG(1)=0.                                                          QDFL  35
      NBLD2=NBL/2                                                       QDFL  36
      NUMBLK=1+(2*NUMNP-1)/NBL                                          QDFL  37
      DO 308 IJKL=1,NUMBLK                                              QDFL  38
      NLESS=(IJKL-2)*NBLD2                                              QDFL  39
      IF(NLESS.LE.0)NLESS=0                                             QDFL  40
      DO 300 NN=1,NUMEL                                                 QDFL  41
      XM=0.                                                             QDFL  42
      YM=0.                                                             QDFL  43
      DO 100 J=1,4                                                      QDFL  44
      I=NP(J,NN)                                                        QDFL  45
      XM=XM+0.25*X(I)                                                   QDFL  46
 100  YM=YM+0.25*Y(I)                                                   QDFL  47
      XK3=ANG(NN)*3.1415926/180.                                        QDFL  48
      COSA=COS(XK3)                                                     QDFL  49
      SINA=SIN(XK3)                                                     QDFL  50
      MAT=NP(5,NN)                                                      QDFL  51
      NP(5,NN)=NP(1,NN)                                                 QDFL  52
      FG(2)=-RO(MAT)                                                    QDFL  53
      XK(1,1)=XK1(MAT)*COSA**2 +XK2(MAT)*SINA**2                        QDFL  54
      XK(2,2)=XK2(MAT)*COSA**2+XK1(MAT)*SINA**2                         QDFL  55
      XK(1,2)=SINA*COSA*(XK1(MAT)-XK2(MAT))                             QDFL  56
      XK(2,1)=XK(1,2)                                                   QDFL  57
C     LOOP ON ELEMENTS FOR QUADRILATERAL ELEMENT                                
      DO 201 II=1,5                                                     QDFL  58
      GG(II)=0.0                                                        QDFL  59
      DO 201 JJ=1,5                                                     QDFL  60
 201  S(II,JJ)=0.0                                                      QDFL  61
      DO 1000 LL=1,4                                                    QDFL  62
      I=NP(LL,NN)                                                       QDFL  63
      J=NP(LL+1,NN)                                                     QDFL  64
      YY(1)=Y(J)-YM                                                     QDFL  65
      YY(2)=YM-Y(I)                                                     QDFL  66
      YY(3)=Y(I)-Y(J)                                                   QDFL  67
      YY(4)=XM-X(J)                                                     QDFL  68
      YY(5)=X(I)-XM                                                     QDFL  69
      YY(6)=X(J)-X(I)                                                   QDFL  70
      D=YY(6)*YY(2)-YY(3)*YY(5)                                         QDFL  71
                                                                                
      IF (D) 97,98,99                                                   QDFL  72
  98  IF (LL-3) 97,1000,97                                              QDFL  73
C......................................................... WRITE IN QDFL
  97  WRITE(6,301) NN                                                   QDFL  74
      NDMP=1                                                            QDFL  75
      GO TO 306                                                         QDFL  76
  99  IF(NTYPE-1) 96,95,96                                              QDFL  77
  96  A1=(X(I)+X(J)+XM)/3.                                              QDFL  78
  95  DO 104 II=1,6                                                     QDFL  79
      LS=IY(II)                                                         QDFL  80
      IS=JY(II,LL)                                                      QDFL  81
      DO 103 JJ=1,6                                                     QDFL  82
      KS=IY(JJ)                                                         QDFL  83
      JS=JY(JJ,LL)                                                      QDFL  84
 103  S(IS,JS)=S(IS,JS)+0.5*YY(II)*XK(LS,KS)*YY(JJ)/D*A1                QDFL  85
      DO 104 MS=1,2                                                     QDFL  86
 104  GG(IS)=GG(IS)+0.5*YY(II)*XK(LS,MS)*FG(MS)*A1                      QDFL  87
      DO 402 KI=1,5                                                     QDFL  88
 402  SLUSH(NN,KI)=S(5,KI)                                              QDFL  89
      SLUSH(NN,6)=GG(5)                                                 QDFL  90
1000  CONTINUE                                                          QDFL  91
      NP(5,NN)=MAT                                                      QDFL  92
      DO 200 II=1,4                                                     QDFL  93
      GG(II)=GG(II)-S(II,5)*GG(5)/S(5,5)                                QDFL  94
      DO 200 JJ=1,4                                                     QDFL  95
 200  S(II,JJ)=S(II,JJ)-S(II,5)*S(5,JJ)/S(5,5)                          QDFL  96
      DO 204 II=1,4                                                     QDFL  97
      L1=NP(II,NN)-NLESS                                                QDFL  98
      IF(L1.GT.0.AND.L1.LE.NBLD2.AND.IJKL.EQ.1) GO TO 303               QDFL  99
      IF (L1.GT.NBLD2.AND.L1.LE.NBL.AND.IJKL.GT.1) GO TO 303            QDFL 100
      GO TO 204                                                         QDFL 101
 303  CONTINUE                                                          QDFL 102
      NPIINN=NP(II,NN)                                                  QDFLA102
      R(NPIINN)=R(NPIINN)+GG(II)                                        QDFL 103
      DO 202 JJ=1,4                                                     QDFL 104
      K2=NP(JJ,NN)-NP(II,NN)+1                                          QDFL 105
      IF (K2-0) 202,202,203                                             QDFL 106
 203  C(L1,K2)=C(L1,K2)+S(II,JJ)                                        QDFL 107
 202  CONTINUE                                                          QDFL 108
 204  CONTINUE                                                          QDFL 109
 306  NP(5,NN)=MAT                                                      QDFL 110
      IF (NN.EQ.NUMEL.AND.NDMP.EQ.1) GO TO 305                          QDFL 111
 300  CONTINUE                                                          QDFL 112
C     MODIFY FOR BOUNDARY CONDITIONS                                            
      DO 307 NJ=1,NBLD2                                                 QDFL 113
      N=NJ+(IJKL-1)*NBLD2                                               QDFL 114
      IF (N.GE.NUMNP+1) GO TO 205                                       QDFL 115
      IF(NDMP.EQ.0) CALL MODIFY (N,MAXBAN,NLESS)                        QDFL 116
 307  CONTINUE                                                          QDFL 117
 205  CONTINUE                                                          QDFL 118
      DO 302 I=1,NBLD2                                                  QDFL 119
      IF (IJKL.EQ.1) GO TO 308                                          QDFL 120
      J=I+(IJKL-2)*NBLD2                                                QDFL 121
C......................................................... WRITE IN QDFL
      WRITE (NDISC) R(J),(C(I,K),K=1,MAXBAN)                            QDFL 122
      DO 302 K=1,MAXBAN                                                 QDFL 123
      NBL2=NBL/2                                                        QDFLA123
      C(I,K)=C(I+NBL2,K)                                                QDFL 124
      C(I+NBL2,K)=0.                                                    QDFL 125
 302  CONTINUE                                                          QDFL 126
 308  CONTINUE                                                          QDFL 127
      DO 304 I=1,NBLD2                                                  QDFL 128
      J=I+(NUMBLK-1)*NBLD2                                              QDFL 129
      IF (J.GT.NUMNP) R(1)=0.                                           QDFL 130
      IF (J.GT.NUMNP) C(I,1)=0.                                         QDFL 131
      IF (J.GT.NUMNP) J=1                                               QDFL 132
C......................................................... WRITE IN QDFL
      WRITE (NDISC) R(J),(C(I,K),K=1,MAXBAN)                            QDFL 133
 304  CONTINUE                                                          QDFL 134
 305  CONTINUE                                                          QDFL 135
 301  FORMAT (30H ZERO OR NEGATIVE AREA ELEMENT, I3/)                   QDFL 136
      RETURN                                                            QDFL 137
      END                                                               QDFL 138
C***********************************************************************        
C	SUBROUTINE FOR ELEMENT FLOW                                    *                                                                              
C***********************************************************************        
      SUBROUTINE ELFLOW(SLUSH)                                          ELFL   1
C     
      PARAMETER (MEL=300,MNT=310)
      IMPLICIT INTEGER*2(I-N)                                           ELFL   1
      COMMON /B/ C(122,31),R(MNT),FX(MNT),X(MNT),Y(MNT),ANG(MEL)      
     1,XK1(30),XK2(30),RO(30),ALPHA(40)                                 ELFL   4
      COMMON /DA/ BETA,HED(20),HITE,HEAD,NPAGE,NDMP,NTYPE,MAXMSH,NUMNP,IELFL   5
     1,NUMEL,MAXBAN,NUMMAT,NUMFSC,NFLCD,MAXIT,MBAND,NUMNPM,NUMELM,NUMMAMELFL   6
     2,NUMFSM,NFLCDM,NBC(MNT),MESH(MNT),NP(5,MEL),NPFS(40),NUMBLK,NBL   ELFL   7
      COMMON /PLO/ P(MNT),MJERA,NPOD,IPOD
C
      DIMENSION SLUSH(MEL,6)                                            ELFL   8
      DIMENSION XK(2,2),YY(2,3),T1(2),T2(2),FG(2),S(6)                  ELFL   9
C
      XK(1,2)=0.0                                                       ELFL  11
      XK(2,1)=0.0                                                       ELFL  12
      N=0                                                               ELFL  13
 405  N=N+1                                                             ELFL  14
      XM=0.                                                             ELFL  15
      YM=0.                                                             ELFL  16
      DO 100 J=1,4                                                      ELFL  17
      I=NP(J,N)                                                         ELFL  18
      XM=XM+X(I)*.25                                                    ELFL  19
 100  YM=YM+Y(I)*.25                                                    ELFL  20
      XK3=ANG(N)*3.141593/180.                                          ELFL  21
      COSA=COS(XK3)                                                     ELFL  22
      SINA=SIN(XK3)                                                     ELFL  23
      MAT=NP(5,N)                                                       ELFL  24
      NP(5,N)=NP(1,N)                                                   ELFL  25
      I=NP(1,N)                                                         ELFL  26
      J=NP(2,N)                                                         ELFL  27
      K=NP(3,N)                                                         ELFL  28
      L=NP(4,N)                                                         ELFL  29
      DO 101 M=1,6                                                      ELFL  30
 101  S(M)=SLUSH(N,M)                                                   ELFL  31
      RM=(S(6)-S(1)*R(I)-S(2)*R(J)-S(3)*R(K)-S(4)*R(L))/S(5)            ELFL  32
      Y1K=COSA*XM+SINA*YM                                               ELFL  33
      Y2K=COSA*YM-SINA*XM                                               ELFL  34
      Q1=0.0                                                            ELFL  35
      Q2=0.0                                                            ELFL  36
      D1=0.0                                                            ELFL  37
      XK(1,1)=XK1(MAT)                                                  ELFL  38
      XK(2,2)=XK2(MAT)                                                  ELFL  39
      FG(1)=-SINA*RO(MAT)                                               ELFL  40
      FG(2)=-COSA*RO(MAT)                                               ELFL  41
C     LOOP ON ELEMENTS FOR QUADRILATERAL ELEMENT                                
      DO 300 NN=1,4                                                     ELFL  42
      I=NP(NN,N)                                                        ELFL  43
      J=NP(NN+1,N)                                                      ELFL  44
      Y1I=COSA*X(I)+SINA*Y(I)                                           ELFL  45
      Y1J=COSA*X(J)+SINA*Y(J)                                           ELFL  46
      Y2I=COSA*Y(I)-SINA*X(I)                                           ELFL  47
      Y2J=COSA*Y(J)-SINA*X(J)                                           ELFL  48
      YY(1,1)=Y2J-Y2K                                                   ELFL  49
      YY(1,2)=Y2K-Y2I                                                   ELFL  50
      YY(1,3)=Y2I-Y2J                                                   ELFL  51
      YY(2,1)=Y1K-Y1J                                                   ELFL  52
      YY(2,2)=Y1I-Y1K                                                   ELFL  53
      YY(2,3)=Y1J-Y1I                                                   ELFL  54
      D=YY(2,3)*YY(1,2)-YY(1,3)*YY(2,2)                                 ELFL  55
      IF(D-0) 301,300,301                                               ELFL  56
 301  D1=D1+D                                                           ELFL  57
      DO 402 II=1,2                                                     ELFL  58
 402  T2(II)=YY(II,1)*R(I)+YY(II,2)*R(J)+YY(II,3)*RM                    ELFL  59
      DO 403 II=1,2                                                     ELFL  60
      T1(II)=0.0                                                        ELFL  61
      DO 403 JJ=1,2                                                     ELFL  62
 403  T1(II)=T1(II)+XK(II,JJ)*(T2(JJ)-FG(JJ)*D)                         ELFL  63
      Q1=Q1-T1(1)                                                       ELFL  64
      Q2=Q2-T1(2)                                                       ELFL  65
 300  CONTINUE                                                          ELFL  66
      NP(5,N)=MAT                                                       ELFL  67
      QA=ABS(D1)                                                        ELFL  68
      IF (QA.LE.0.1E-25) D1=0.1E-25                                     ELFL  69
      Q1=Q1/D1                                                          ELFL  70
      Q2=Q2/D1                                                          ELFL  71
      QA=ABS(Q1)                                                        ELFL  72
      QB=ABS(Q2)                                                        ELFL  73
      IF (QA.LT.0.1E-25) QC=0.1E-37                                     ELFL  74
      IF (QA.GE.0.1E-25) QC=Q1**2                                       ELFL  75
      IF (QB.LT.0.1E-25) QD=0.1E-37                                     ELFL  76
      IF (QB.GE.0.1E-25) QD=Q2**2                                       ELFL  77
      Q3=SQRT(QC+QD)                                                    ELFL  78
      IF(Q1-1.0E-06)21,20,21                                            ELFL  79
  20  IF(Q2-1.0E-06)30,31,32                                            ELFL  80
  30  Q4=-1.570796                                                      ELFL  81
      GO TO 35                                                          ELFL  82
  31  Q4=0.0                                                            ELFL  83
      GO TO 35                                                          ELFL  84
  32  Q4=1.570796                                                       ELFL  85
      GO TO 35                                                          ELFL  86
  21  CONTINUE                                                          ELFL  87
      IF(QA.GT.0.1E-25) Q4=Q2/Q1                                        ELFL  88
      IF(QA.LE.0.1E-25) Q4=Q2/0.1E-25                                   ELFL  89
      IF (ABS(Q4).LT.0.1E-05) Q4=0.                                     ELFL  90
      IF (ABS(Q4).GE.0.1E-05) Q4=ATAN(Q4)                               ELFL  91
      IF(Q1-1.0E-06)34,20,35                                            ELFL  92
  34  Q4=3.141593+Q4                                                    ELFL  93
  35  Q4=Q4+XK3                                                         ELFL  94
      Q4=180.*Q4/3.141593                                               ELFL  95
      S(1)=Q1                                                           ELFL  96
      S(2)=Q2                                                           ELFL  97
      S(3)=ANG(N)                                                       ELFL  98
      S(4)=Q3                                                           ELFL  99
      S(5)=Q4                                                           ELFL 100
      DO 400 M=1,5                                                      ELFL 101
      SLUSH(N,M)=S(M)                                                   ELFL 102
 400  CONTINUE                                                          ELFL 103
      IF(N.LT.NUMEL) GO TO 405                                          ELFL 104
      RETURN                                                            ELFL 105
      END                                                               ELFL 106
C*********************************************************************** 
C	SUBROUTINE FOR MODIFICATION                                    *
C***********************************************************************        
      SUBROUTINE MODIFY (N,MM,NN)                                       MODI   1
C        INCLUDE 'FEDAR.CMM'
      PARAMETER (MEL=300,MNT=310)                                       MODI   1
      IMPLICIT INTEGER*2(I-N)                                           MODI   2
      COMMON /B/ C(122,31),R(MNT),FX(MNT),X(MNT),Y(MNT),ANG(MEL)        MODI   3
     1,XK1(30),XK2(30),RO(30),ALPHA(40)                                 MODI   4
      COMMON /DA/ BETA,HED(20),HITE,HEAD,NPAGE,NDMP,NTYPE,MAXMSH,NUMNP,IMODI   5
     1,NUMEL,MAXBAN,NUMMAT,NUMFSC,NFLCD,MAXIT,MBAND,NUMNPM,NUMELM,NUMMAMMODI   6
     2,NUMFSM,NFLCDM,NBC(MNT),MESH(MNT),NP(5,MEL),NPFS(40),NUMBLK,NBL   MODI   7
      COMMON /PLO/ P(MNT),MJERA,NPOD,IPOD
C
      ROE=RO(1)                                                         MODI   8
      IF (ABS(ROE).LE.0.1E-25) ROE=1.                                   MODI   9
      IF(NBC(N))71,70,72                                                MODI  10
  71  R(N)=R(N)+FX(N)                                                   MODI  11
      GO TO 70                                                          MODI  12
  72  N1=N+1                                                            MODI  13
      DO 73 K=2,MM                                                      MODI  14
      N2=N1-K                                                           MODI  15
      IF (N2-0) 74,74,75                                                MODI  16
  75  R(N2)=R(N2)-C(N2-NN,K)*FX(N)*ROE                                  MODI  17
      C(N2-NN,K)=0.0                                                    MODI  18
  74  M=N+K-1                                                           MODI  19
      IF (M-NUMNP) 76,76,73                                             MODI  20
  76  R(M)=R(M)-C(N-NN,K)*FX(N)*ROE                                     MODI  21
      C(N-NN,K)=0.0                                                     MODI  22
  73  CONTINUE                                                          MODI  23
      C(N-NN,1)=1.0                                                     MODI  24
      R(N)=FX(N)*ROE                                                    MODI  25
  70  CONTINUE                                                          MODI  26
      RETURN                                                            MODI  27
      END                                                               MODI  28
C***********************************************************************
C	SUBROUTINE FOR EQUATION SOLUTION WITH BANDAGE                  *
C***********************************************************************
      SUBROUTINE BANSOL (MM,NUMBLK,A,B,MBW)
C
      IMPLICIT INTEGER*2(I-N)
      DIMENSION A(122,31),B(300)                                                
C
      REWIND 1                                                          BANS   5
      REWIND 2                                                          BANS   6
C                                                                               
C                                                                               
      MBAND=MM                                                          BANS   7
      NN=MBW                                                            BANS   8
      NL=NN+1                                                           BANS   9
      NH=NN+NN                                                          BANS  10
      NB=0                                                              BANS  11
      GO TO 150                                                         BANS  12
C...........................................       
C     REDUCE EQUATIONS BY BLOCKS           .                                     
C........................................... 
C                                                                               
C     1. SHIFT BLOCK OF EQUATIONS                                               
C                                                                               
 100  NB=NB+1                                                           BANS  13
      DO 125 N=1,NN                                                     BANS  14
      NM=NN+N                                                           BANS  15
      B(N)=B(NM)                                                        BANS  16
      B(NM)=0.0                                                         BANS  17
      DO 125 M=1,MM                                                     BANS  18
      A(N,M)=A(NM,M)                                                    BANS  19
 125  A(NM,M)=0.0                                                       BANS  20
C                                                                               
C     2. READ NEXT BLOCK OF EQUATIONS INTO CORE                                 
C                                                                               
      IF (NUMBLK-NB) 150,200,150                                        BANS  21
 150  CONTINUE                                                          BANS  22
      K=1                                                               BANS  23
      DO 1 N=NL,NH                                                      BANS  24
C.......................................................... READ IN BANS
   1  READ (K ) B(N),(A(N,M),M=1,MBAND)                                 BANS  25
      IF (NB) 200,100,200                                               BANS  26
C                                                                       $
C     3. REDUCE BLOCK OF EQUATIONS                                              
C                                                                               
 200  DO 300 N=1,NN                                                     BANS  27
      IF (A(N,1)) 225,300,225                                           BANS  28
 225  B(N)=B(N)/A(N,1)                                                  BANS  29
      DO 275 L=2,MM                                                     BANS  30
      IF (A(N,L)) 230,275,230                                           BANS  31
 230  C=A(N,L)/A(N,1)                                                   BANS  32
      I=N+L-1                                                           BANS  33
      J=0                                                               BANS  34
      DO 250 K=L,MM                                                     BANS  35
      J=J+1                                                             BANS  36
 250  A(I,J)=A(I,J)-C*A(N,K)                                            BANS  37
      B(I)=B(I)-A(N,L)*B(N)                                             BANS  38
      A(N,L)=C                                                          BANS  39
 275  CONTINUE                                                          BANS  40
 300  CONTINUE                                                          BANS  41
C                                                                               
C     4. WRITE BLOCK OF REDUCED EQUATIONS ON  TAPE 2                            
C                                                                               
      IF (NUMBLK-NB) 375,400,375                                        BANS  42
 375  CONTINUE                                                          BANS  43
      K=2                                                               BANS  44
      DO 2 N=1,NN                                                       BANS  45
C......................................................... WRITE IN BANS
   2  WRITE(K ) B(N),(A(N,M),M=2,MBAND)                                 BANS  46
      GO TO 100                                                         BANS  47
C...........................................        
C     BACK-SUBSTITUTION                    .                                     
C...........................................       
 400  DO 450 M=1,NN                                                     BANS  48
      N=NN+1-M                                                          BANS  49
      DO 425 K=2,MM                                                     BANS  50
      L=N+K-1                                                           BANS  51
 425  B(N)=B(N)-A(N,K)*B(L)                                             BANS  52
      NM=N+NN                                                           BANS  53
      B(NM)=B(N)                                                        BANS  54
 450  A(NM,NB)=B(N)                                                     BANS  55
      NB=NB-1                                                           BANS  56
      IF (NB) 475,500,475                                               BANS  57
 475  CONTINUE                                                          BANS  58
      REWIND 2                                                          BANS  59
      K=2                                                               BANS  60
      DO 3 MMMMM=1,NB                                                   BANS  61
      DO 3 N=1,NN                                                       BANS  62
C.......................................................... READ IN BANS
   3  READ (K ) B(N),(A(N,M),M=2,MBAND)                                 BANS  63
      GO TO 400                                                         BANS  64
C...........................................       
C     ORDER UNKNOWNS IN B ARRAY            .         
C...........................................        
 500  K=0                                                               BANS  65
      DO 600 NB=1,NUMBLK                                                BANS  66
      DO 600 N=1,NN                                                     BANS  67
      NM=N+NN                                                           BANS  68
      K=K+1                                                             BANS  69
 600  B(K)=A(NM,NB)                                                     BANS  70
      RETURN                                                            BANS  71
      END                                                               BANS  72
